﻿/*
 * @author Minos 2015.10.14
 */
var Key = {}; Key.KeyList = { BackSpace: 8, Tab: 9, Enter: 13, Shift: 16, Ctrl: 17, Alt: 18, PauseBreak: 19, CapsLock: 20, ESC: 27, Space: 32, PageUp: 33, PageDown: 34, End: 35, Home: 36, Left: 37, Up: 38, Right: 39, Down: 40, Insert: 45, Delete: 46, "0": 48, "1": 49, "2": 50, "3": 51, "4": 52, "5": 53, "6": 54, "7": 55, "8": 56, "9": 57, A: 65, B: 66, C: 67, D: 68, E: 69, F: 70, G: 71, H: 72, I: 73, J: 74, K: 75, L: 76, M: 77, N: 78, O: 79, P: 80, Q: 81, R: 82, S: 83, T: 84, U: 85, V: 86, W: 87, X: 88, Y: 89, Z: 90, Win: 91, WinNB: 92, ContextMenu: 93, FN: 94, Num0: 96, Num1: 97, Num2: 98, Num3: 99, Num4: 100, Num5: 101, Num6: 102, Num7: 103, Num8: 104, Num9: 105, "Num/": 111, "Num*": 106, "Num+": 107, "Num-": 109, "Num.": 110, F1: 112, F2: 113, F3: 114, F4: 115, F5: 116, F6: 117, F7: 118, F8: 119, F9: 120, F10: 121, F11: 122, F12: 123, NumLock: 144, HistoryBack: 166, HistoryForward: 167, MyFavorite: 171, PlayPause: 179, Email: 180, ";": 186, "=": 187, ",": 188, "-": 189, ".": 190, "/": 191, "`": 192, "[": 219, "\\": 220, "]": 221, "'": 222 }; Key.Listen = function () { function t(n, t, r) { i ? n.addEventListener(t, function (t) { return r.call(n, t) }, !1) : n.attachEvent("on" + t, function (t) { return r.call(n, t) }) } var i = window.addEventListener !== undefined, n = []; return function (i, r, u) { t(i, "keydown", function (t) { var e, f; if (u) { if ((e = t.keyCode, n.indexOf(e) == -1) && n.push(e), u.length == n.length) { for (f = 0; f < n.length; f++) if (e = typeof u[f] == "string" ? Key.KeyList[u[f]] : u[f], n.indexOf(e) == -1) return; r.call(i, t, t.keyCode) } } else r.call(i, t, t.keyCode) }); t(i, "keyup", function (t) { n.splice(n.indexOf(t.keyCode), 1) }) } }();
function bind(elem, type, fn) { var newfn = function () { fn.apply(elem, arguments); }; if (elem.addEventListener) { elem.addEventListener(type, newfn, false); } else { elem.attachEvent("on" + type, newfn); } return newfn; }
Array.prototype.indexOf = Array.prototype.indexOf || function (val, start) { var i; i = start || 0; for (; i < this.length; i++) { if (this[i] === val) { return i; } } return -1; };

/*
 * @author Minos 2015.10.14
 */

var invert = false;


(function () {

    function vkb(map) {

        this.kmap = map;
        this.cmap = {};
        this.presskey = [];
        this._enable = true;
        this._prevent = true;

    }

    vkb.prototype = {

        init: function (id, callback) {

            var self = this;

            this.container = typeof (id) === "string" ? document.getElementById(id) : id;
            this.callback = callback;

            for (var p in this.kmap) {
                this.cmap[Key.KeyList[p]] = this.kmap[p];
            }
        },

        addKey: function (kc) {

            var kc, i;

            if (this.cmap[kc] != undefined) {
                if (this.presskey.indexOf(kc) == -1) {
                    for (i = 0; i < this.cmap[kc].length; i++) {
                        cm(this.container, kc, this.cmap[kc][i]);
                    }
                    this.presskey.push(kc);

                    if (this.callback) {
                        this.callback(kc);
                    }
                }
            }
        },
        removeKey: function (kc) {

            var dom, index, i;

            if ((index = this.presskey.indexOf(kc)) != -1) {
                dom = this.container.querySelectorAll('.ag-key-' + kc);//document.getElementsByClassName('ag-key-' + kc);

                if (dom.length) {
                    Array.prototype.forEach.call(dom, function (elem) {

                        elem.classList.remove('on');

                        setTimeout(function () {

                            if (elem && elem.parentNode) {
                                elem.parentNode.removeChild(elem);
                            }
                        }, 250);
                    });
                }
                this.presskey.splice(index, 1);
            }
        }
    };

    function cm(container, id, opt) {

        //key1
        var dom = document.createElement('div');

        dom.className = "ag-keyboard-press ag-key-" + id;
        dom.style.left = opt[0] + "px";
        dom.style.top = opt[1] + "px";
        dom.style.width = opt[2] + "px";
        dom.style.height = opt[3] + "px";
        dom.style.backgroundPosition = [-opt[0] + "px", -opt[1] + "px"].join(' ');

        setTimeout(function () { dom.classList.add('on') }, 0);
        container.appendChild(dom);

        //key2
        var dom2 = document.createElement('div');

        dom2.className = "ag-keyboard-press cover ag-key-" + id;
        dom2.style.left = opt[0] + "px";
        dom2.style.top = opt[1] + "px";
        dom2.style.width = opt[2] + "px";
        dom2.style.height = opt[3] + "px";
        dom2.style.backgroundPosition = [-opt[0] + "px", -opt[1] + "px"].join(' ');

        setTimeout(function () { dom2.classList.add('on') }, 0);
        container.appendChild(dom2);
    }

    window.AntiGhost = vkb;

})();